#include <iostream>
#include <vector>
#include <conio.h>

using namespace std;

struct Input
    {
        vector<double> numbers;
        size_t bin_count{};
    };

    Input input_data()
    {
        size_t number_count;
        cin >> number_count;

        Input in;
        in.numbers.resize(number_count);
        for (size_t i = 0; i < number_count; i++)
        {
            cin >> in.numbers[i];
        }
        cin>> in.bin_count;
        return in;
    }


int main()
{

    const size_t screen_width = 80;
    const size_t max_asterisk = screen_width - 3 - 1;
    int i, j;


    Input in = input_data();



    vector <size_t> bins(in.bin_count);

    double min = in.numbers[0];
    double max = in.numbers[0];
    for (double x : in.numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }

    double bin_size = (max - min) / in.bin_count;

    for (size_t i = 0; i < in.numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < in.bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= in.numbers[i]) && (in.numbers[i] < hi))
            {
                bins[j] ++;
                found = true;
            }
        }
        if (!found)
        {
            bins[in.bin_count - 1]++;
        }
    }

    double max_count;
    max_count = bins[0];
    for (i=0; i< in.bin_count; i++)
    {
        if (max_count<bins[i])
        {
            max_count=bins[i];
        }
    }

    size_t height;
    bool flag = false;
    if(max_count>max_asterisk)
    {
        flag=true;
    }
    for (j = 0; j < in.bin_count; j++)
    {
        if (bins[j] < 100)
        {
            cout << " ";
        }
        if (bins[j] < 10)
        {
            cout << " ";
        }
        cout << bins[j] << "|";

        if (flag)
        {
            height = max_asterisk * (static_cast<double>(bins[j]) / max_count);
        }
        else
        {
            height=bins[j];
        }
        for (i = 0; i < height; i++)
        {
            cout << "*";
        }
        cout << endl;
    }
    _getch();
    return 0;
}
